Loading...
Searching...
No Matches
Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase Class Reference

`#include <IGeomBase.h>`

Inheritance diagram for Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase:
[legend]
Collaboration diagram for Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase:
[legend]

## Classes

class | Sample

## Public Types

typedef IGeomBase | this_type
Public Types inherited from Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >
typedef GeomBaseSchemaInfo | info_type
Public Types inherited from Alembic::Abc::ALEMBIC_VERSION_NS::ISchema< GeomBaseSchemaInfo >
typedef GeomBaseSchemaInfo | info_type
typedef ISchema< GeomBaseSchemaInfo > | this_type
Public Types inherited from Alembic::Abc::ALEMBIC_VERSION_NS::ICompoundProperty
typedef ICompoundProperty | this_type

## Public Member Functions

| IGeomBase ()
| The default constructor creates an empty GeomBase.
| IGeomBase (const ICompoundProperty &iParent, const std::string &iName, const Abc::Argument &iArg0=Abc::Argument(), const Abc::Argument &iArg1=Abc::Argument())
| IGeomBase (const ICompoundProperty &iThis, const Abc::Argument &iArg0=Abc::Argument(), const Abc::Argument &iArg1=Abc::Argument())
| IGeomBase (const ICompoundProperty &iThis, Abc::WrapExistingFlag iFlag, const Abc::Argument &iArg0=Abc::Argument(), const Abc::Argument &iArg1=Abc::Argument())
| IGeomBase (const IGeomBase &iCopy)
| Copy constructor.
size_t | getNumSamples () const
| Default assignment operator used.
bool | isConstant () const
AbcA::TimeSamplingPtr | getTimeSampling () const
void | get (Sample &oSample, const Abc::ISampleSelector &iSS=Abc::ISampleSelector()) const
Sample | getValue (const Abc::ISampleSelector &iSS=Abc::ISampleSelector()) const
Abc::ICompoundProperty | getArbGeomParams () const
Abc::ICompoundProperty | getUserProperties () const
void | reset ()
bool | valid () const
| ALEMBIC_OVERRIDE_OPERATOR_BOOL (IGeomBase::valid())
Public Member Functions inherited from Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >
| IGeomBaseSchema ()
void | init (const Abc::Argument &iArg0, const Abc::Argument &iArg1)
Abc::IBox3dProperty | getSelfBoundsProperty () const
Abc::IBox3dProperty | getChildBoundsProperty () const
ICompoundProperty | getArbGeomParams () const
ICompoundProperty | getUserProperties () const
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::ISchema< GeomBaseSchemaInfo >
| ISchema ()
virtual | ~ISchema ()
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::ICompoundProperty
| ICompoundProperty ()
| ICompoundProperty (const ICompoundProperty &iParent, const std::string &iName, const Argument &iArg0=Argument())
| ICompoundProperty (AbcA::CompoundPropertyReaderPtr iPtr, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
| ICompoundProperty (AbcA::CompoundPropertyReaderPtr iPtr, WrapExistingFlag, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
| ICompoundProperty (const IObject &iObject, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
| ICompoundProperty (const IObject &iObject, TopFlag, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
| ~ICompoundProperty ()
size_t | getNumProperties () const
| Returns the number of properties contained in this ICompoundProperty.
const AbcA::PropertyHeader & | getPropertyHeader (size_t i) const
const AbcA::PropertyHeader * | getPropertyHeader (const std::string &iName) const
ICompoundProperty | getParent () const
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::CompoundPropertyReaderPtr >
const AbcA::PropertyHeader & | getHeader () const
const std::string & | getName () const
AbcA::PropertyType | getPropertyType () const
bool | isScalar () const
bool | isArray () const
bool | isCompound () const
bool | isSimple () const
const AbcA::MetaData & | getMetaData () const
const AbcA::DataType & | getDataType () const
AbcA::TimeSamplingPtr | getTimeSampling () const
IObject | getObject () const
AbcA::CompoundPropertyReaderPtr | getPtr () const
void | reset ()
bool | valid () const
| ALEMBIC_OPERATOR_BOOL (valid())
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
ErrorHandler & | getErrorHandler () const
ErrorHandler::Policy | getErrorHandlerPolicy () const

## Static Public Member Functions

static bool | matches (const AbcA::MetaData &iMetaData, SchemaInterpMatching iMatching=kStrictMatching)
static bool | matches (const AbcA::PropertyHeader &iHeader, SchemaInterpMatching iMatching=kStrictMatching)
Static Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::ISchema< GeomBaseSchemaInfo >
static const char * | getSchemaTitle ()
static const char * | getDefaultSchemaName ()
static bool | matches (const AbcA::MetaData &iMetaData, SchemaInterpMatching iMatching=kStrictMatching)

## Additional Inherited Members

Protected Types inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::CompoundPropertyReaderPtr >
typedef IBasePropertyT< AbcA::CompoundPropertyReaderPtr > | this_type
typedef IBasePropertyT< AbcA::CompoundPropertyReaderPtr > | operator_bool_base_type
Protected Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::CompoundPropertyReaderPtr >
| IBasePropertyT ()
Protected Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
| Base ()
| Base (ErrorHandler::Policy iPolicy)
| Base (const Base &iCopy)
Base & | operator= (const Base &iCopy)
bool | valid () const
void | reset ()
Protected Attributes inherited from Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >
Abc::IBox3dProperty | m_selfBoundsProperty
Abc::IBox3dProperty | m_childBoundsProperty
Abc::ICompoundProperty | m_arbGeomParams
Abc::ICompoundProperty | m_userProperties
Protected Attributes inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::CompoundPropertyReaderPtr >
AbcA::CompoundPropertyReaderPtr | m_property

## Detailed Description

IGeomBase - A generic base set of properties and methods that encapsulate things common to AbcGeom types that have a physical volume.

- self bounds
- children bounds (optional)
- argbGeomParams (optional)
- userProperties (optional) This class is a concrete instantiation of IGeomBaseSchema. Your archive might contain PolyMesh and SubD and Curves and Points objects etc. This class, IGeomBase, gives you access to the generic parts of those objects. For example, if you just wish to iterate through an archive's hierarchy to examine bounding regions this class could be helpful to you. Then when you actually need to access the real data in the geometric type you can always create the needed type of I<geom type> object> via kWrapExisting.

Definition at line 206 of file IGeomBase.h.

## Member Typedef Documentation

## this_type

typedef IGeomBase Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::this_type

Definition at line 209 of file IGeomBase.h.

## Constructor & Destructor Documentation

## IGeomBase() [1/5]

Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::IGeomBase | ( |  | ) |

inline

The default constructor creates an empty GeomBase.

By convention we always define this_type in AbcGeom classes. Used by unspecified-bool-type conversion below

Definition at line 240 of file IGeomBase.h.

Referenced by IGeomBase().

Here is the caller graph for this function:

## IGeomBase() [2/5]

Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::IGeomBase | ( | const ICompoundProperty & | iParent,
|  | const std::string & | iName,
|  | const Abc::Argument & | iArg0 = Abc::Argument(),
|  | const Abc::Argument & | iArg1 = Abc::Argument() )

inline

Definition at line 242 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::IGeomBaseSchema(), Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::init(), and Alembic::Abc::ALEMBIC_VERSION_NS::kNoMatching.

Here is the call graph for this function:

## IGeomBase() [3/5]

Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::IGeomBase | ( | const ICompoundProperty & | iThis,
|  | const Abc::Argument & | iArg0 = Abc::Argument(),
|  | const Abc::Argument & | iArg1 = Abc::Argument() )

inline

Definition at line 254 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::IGeomBaseSchema(), Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::init(), and Alembic::Abc::ALEMBIC_VERSION_NS::kNoMatching.

Here is the call graph for this function:

## IGeomBase() [4/5]

Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::IGeomBase | ( | const ICompoundProperty & | iThis,
|  | Abc::WrapExistingFlag | iFlag,
|  | const Abc::Argument & | iArg0 = Abc::Argument(),
|  | const Abc::Argument & | iArg1 = Abc::Argument() )

inline

Definition at line 264 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::IGeomBaseSchema(), Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::init(), and Alembic::Abc::ALEMBIC_VERSION_NS::kNoMatching.

Here is the call graph for this function:

## IGeomBase() [5/5]

Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::IGeomBase | ( | const IGeomBase & | iCopy | ) |

inline

Copy constructor.

Definition at line 274 of file IGeomBase.h.

References IGeomBase(), and Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::IGeomBaseSchema().

Here is the call graph for this function:

## Member Function Documentation

## ALEMBIC_OVERRIDE_OPERATOR_BOOL()

Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::ALEMBIC_OVERRIDE_OPERATOR_BOOL | ( | IGeomBase::valid() |  | ) |

unspecified-bool-type operator overload. ...

References valid().

Here is the call graph for this function:

## get()

void Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::get | ( | Sample & | oSample,
|  | const Abc::ISampleSelector & | iSS = Abc::ISampleSelector() ) const

inline

Definition at line 313 of file IGeomBase.h.

References ALEMBIC_ABC_SAFE_CALL_BEGIN, ALEMBIC_ABC_SAFE_CALL_END, Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::Sample::m_selfBounds, and Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::m_selfBoundsProperty.

Referenced by getValue().

Here is the caller graph for this function:

## getArbGeomParams()

Abc::ICompoundProperty Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::getArbGeomParams | ( |  | ) | const

inline

Definition at line 332 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::m_arbGeomParams.

## getNumSamples()

size_t Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::getNumSamples | ( |  | ) | const

inline

Default assignment operator used.

Return the number of samples contained in the property. This can be any number, including zero. This returns the number of samples that were written, independently of whether or not they were constant.

Definition at line 290 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::m_selfBoundsProperty.

## getTimeSampling()

AbcA::TimeSamplingPtr Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::getTimeSampling | ( |  | ) | const

inline

Time sampling Information.

Definition at line 300 of file IGeomBase.h.

References Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getArchive(), Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::CompoundPropertyReaderPtr >::getObject(), Alembic::Abc::ALEMBIC_VERSION_NS::IArchive::getTimeSampling(), and Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::m_selfBoundsProperty.

Here is the call graph for this function:

## getUserProperties()

Abc::ICompoundProperty Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::getUserProperties | ( |  | ) | const

inline

Definition at line 335 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::m_userProperties.

## getValue()

Sample Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::getValue | ( | const Abc::ISampleSelector & | iSS = Abc::ISampleSelector() | ) | const

inline

Definition at line 324 of file IGeomBase.h.

References get().

Here is the call graph for this function:

## isConstant()

bool Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::isConstant | ( |  | ) | const

inline

Ask if we're constant - no change in value amongst samples, regardless of the time sampling.

Definition at line 295 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >::m_selfBoundsProperty.

## matches() [1/2]

bool Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::matches | ( | const AbcA::MetaData & | iMetaData,
|  | SchemaInterpMatching | iMatching = kStrictMatching )

inline static

This will check whether or not a given entity (as represented by metadata) strictly matches the interpretation of this schema object.

Definition at line 362 of file IGeomBase.h.

References Alembic::Abc::ALEMBIC_VERSION_NS::kNoMatching, Alembic::Abc::ALEMBIC_VERSION_NS::kSchemaTitleMatching, and Alembic::Abc::ALEMBIC_VERSION_NS::kStrictMatching.

Referenced by matches().

Here is the caller graph for this function:

## matches() [2/2]

bool Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::matches | ( | const AbcA::PropertyHeader & | iHeader,
|  | SchemaInterpMatching | iMatching = kStrictMatching )

inline static

This will check whether or not a given object (as represented by an object header) strictly matches the interpretation of this schema object, as well as the data type.

Definition at line 381 of file IGeomBase.h.

References Alembic::Abc::ALEMBIC_VERSION_NS::kStrictMatching, and matches().

Here is the call graph for this function:

## reset()

void Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::reset | ( |  | ) |

inline virtual

Reset returns this function set to an empty, default state.

Reimplemented from Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >.

Definition at line 340 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< INFO >::reset().

Here is the call graph for this function:

## valid()

bool Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBase::valid | ( |  | ) | const

inline virtual

Valid returns whether this function set is valid.

Reimplemented from Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< GeomBaseSchemaInfo >.

Definition at line 348 of file IGeomBase.h.

References Alembic::AbcGeom::ALEMBIC_VERSION_NS::IGeomBaseSchema< INFO >::valid().

Referenced by ALEMBIC_OVERRIDE_OPERATOR_BOOL().

Here is the call graph for this function:
Here is the caller graph for this function:

The documentation for this class was generated from the following file:

- opt/local/include/Alembic/AbcGeom/IGeomBase.h